package db

import (
	"applet/app/cfg"
	"applet/app/utils/logx"
	"fmt"
	"github.com/syyongx/php2go"
	"regexp"
	"strings"

	"github.com/gin-gonic/gin"
)

func ReformatStr(str string, c *gin.Context) string {
	protocol := SysCfgGet(c, "file_bucket_scheme")
	domain := SysCfgGet(c, "file_bucket_host")

	// PNG
	replaceList := reformatPng(str)
	l := removeDuplicateElement(replaceList)
	for _, s := range l {
		if strings.Contains(s, "http") {
			continue
		}
		s = strings.ReplaceAll(s, `\`, "")
		s = php2go.Rawurlencode(s)
		new := fmt.Sprintf("%s://%s/%s", protocol, domain, s)
		if skipHTTPPng(new) {
			continue
		}
		ss := s
		s = strings.ReplaceAll(s, `"`, "")
		str = strings.Replace(str, ss, `"`+new+`"`, -1)
	}

	// JPG
	replaceList = reformatJPG(str)
	l = removeDuplicateElement(replaceList)
	for _, s := range l {
		if strings.Contains(s, "http") {
			continue
		}
		s = strings.ReplaceAll(s, `\`, "")
		s = php2go.Rawurlencode(s)
		new := fmt.Sprintf("%s://%s/%s", protocol, domain, s)
		if skipHTTPPng(new) {
			continue
		}
		ss := s
		s = strings.ReplaceAll(s, `"`, "")
		str = strings.Replace(str, ss, `"`+new+`"`, -1)
	}

	// GIF
	replaceList = reformatGIF(str)
	l = removeDuplicateElement(replaceList)
	for _, s := range l {
		if strings.Contains(s, "http") {
			continue
		}
		s = strings.ReplaceAll(s, `\`, "")
		s = php2go.Rawurlencode(s)
		new := fmt.Sprintf("%s://%s/%s", protocol, domain, s)
		if skipHTTPPng(new) {
			continue
		}
		ss := s
		s = strings.ReplaceAll(s, `"`, "")
		str = strings.Replace(str, ss, `"`+new+`"`, -1)
	}

	return str
}

// 正则匹配
func reformatPng(data string) []string {
	re, _ := regexp.Compile(`"([^\"]*.png")`)
	list := re.FindAllString(data, -1)
	return list
}

func skipHTTPPng(data string) bool {
	re, _ := regexp.Compile(`(http|https):\/\/([^\"]*.png)`)
	return re.MatchString(data)
}

// 正则匹配
func reformatJPG(data string) []string {
	re, _ := regexp.Compile(`"([^\"]*.jpg")`)
	list := re.FindAllString(data, -1)
	return list
}

// 正则匹配
func reformatGIF(data string) []string {
	re, _ := regexp.Compile(`"([^\"]*.gif")`)
	list := re.FindAllString(data, -1)
	return list
}

func removeDuplicateElement(addrs []string) []string {
	result := make([]string, 0, len(addrs))
	temp := map[string]int{}
	i := 1
	for _, item := range addrs {
		if _, ok := temp[item]; !ok {
			temp[item] = i
			result = append(result, item)
			continue
		}
		temp[item] = temp[item] + 1
	}
	// fmt.Println(temp)
	return result
}

// 单挑记录获取
func SysCfgGet(c *gin.Context, key string) string {
	eg := DBs[c.GetString("mid")]
	if !cfg.Prd {
		myCfg, err := SysCfgGetOne(eg, key)
		if err != nil || myCfg == nil {
			_ = logx.Error(err)
			return ""
		}
		return myCfg.Val
	}
	res := SysCfgFind(c, key)
	//fmt.Println(res)
	if _, ok := res[key]; !ok {
		return ""
	}
	return res[key]
}

// 多条记录获取
func SysCfgFind(c *gin.Context, keys ...string) map[string]string {
	masterId := c.GetString("mid")
	eg := DBs[c.GetString("mid")]
	res := map[string]string{}
	//TODO::判断keys长度(大于5个直接查数据库)
	if len(keys) > 5 {
		cfgList, _ := SysCfgGetAll(eg)
		if cfgList == nil {
			return nil
		}
		for _, v := range *cfgList {
			res[v.Key] = v.Val
		}
	} else {
		for _, key := range keys {
			res[key] = SysCfgGetWithDb(eg, masterId, key)
		}
	}
	return res
}
